# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.1.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [unreleased]

### Added

- Packagin with Nix flakes (with nixpkgs buildRustPackage) [!16](https://gitlab.cern.ch/wotsubo/endcap-sl-software-ri-generator/-/merge_requests/16)
- Now xml metadata can be overwritten with corresponding environmental variables. [!17](https://gitlab.cern.ch/wotsubo/endcap-sl-software-ri-generator/-/merge_requests/17)
- Support value element just under the register element by inserting single field during conversion. [!18](https://gitlab.cern.ch/wotsubo/endcap-sl-software-ri-generator/-/merge_requests/18)

### Changed

- Improve error message from syn in generator. !15
- Removed top level module (register_interface), and now it can have arbitrary name.
- Use full path `RegisterSpec`s to avoid unused `use`
- Use `u8` and `u16` for `T` of registers when the mask is 0xff or 0xffff, instead of defining new tuple struct.

## [0.3.1] - 2025-04-11

### Changed

- Moved register value mask definitions from reg module to field value impl.
- Updated error messages for #[from] attributed errors.

## [0.3.0] - 2025-03-27

### Added

- Added register map validator and flattened map generator.
- Allow register with mask and fields iff the masks are matched.

### Changed

- Changed block, register type definitions to support multiple backends. See [the merge request at mpsoc software](https://gitlab.cern.ch/wotsubo/mpsoc-software/-/merge_requests/9) for more information.

### Fixed

- Avoid mask and value constant name duplication by inserting `_VAL_` to value constants.

## [0.2.0] - 2025-02-12

### Added

- Embedding XML git metadata
- New high-level API (`generate` function)

### Fixed

- Loosen Cargo.toml dependencies
- Separate bin crate as optional feature to reduce dependency

## [0.1.0] - 2025-02-07

### Added

- Implemented basic code generation covering current CSR XML.

[unreleased]: https://gitlab.cern.ch/wotsubo/endcap-sl-software-ri-generator/-/compare/v0.3.1...main
[0.3.1]: https://gitlab.cern.ch/wotsubo/endcap-sl-software-ri-generator/-/compare/v0.3.0...v0.3.1
[0.3.0]: https://gitlab.cern.ch/wotsubo/endcap-sl-software-ri-generator/-/compare/v0.2.0...v0.3.0
[0.2.0]: https://gitlab.cern.ch/wotsubo/endcap-sl-software-ri-generator/-/compare/v0.1.0...v0.2.0
[0.1.0]: https://gitlab.cern.ch/wotsubo/endcap-sl-software-ri-generator/~/tags/v0.1.0
